public class Calcolatrice {
  private double operando; // ultimo operando inserito
  private double memoria; // accumulatore risultato
  private char operazione; // tipo di operatore aritmetico (+,-,*,/)
  private boolean errore; // errore di calcolo
  
 public Calcolatrice() {
   memoria=0.0;
   operando=0.0;
   operazione='#'; // nessun operatore impostato
   errore=false;
 }
//imposta operatore algebrico
 public void setOperazione(char operazione) {
  if (!errore)
   if ( (operazione=='+') || (operazione=='-') ||(operazione=='*') || (operazione=='/')) {
    this.operazione=operazione;
    setMemoria(getOperando());
   }
 }
// restituisce ultima operazione aritmetica impostata
 private char getOperazione(){
   return operazione;
 }
// imposta operando
 public void setOperando(double valore) {
   if (!errore)
    operando=valore;
 }
// restituisce operando
 public double getOperando() {
  return operando;
 }
// imposta accumulatore
 private void setMemoria(double valore) {
   memoria=valore;
 }
// restituisce valore accumulatore
 private double getMemoria() {
   return memoria;
 }
// cambio segno operando corrente
 public void cambiaSegno() {
  setOperando(-1.0*getOperando());
 }
// reset calcolatrice
 public void cancella() {
  setMemoria(0.0);
  operazione='#';
  errore=false;
 }
// cancella ultimo operando
 public void cancellaUltimoOperando() {
  setOperando(0.0);
  errore=false;
 }
// addizione
 private void addiziona() {
   if (!errore) {
    setOperando(getMemoria()+operando);
    setMemoria(getOperando());
   }
 }
//sottrazione
 private void sottrai() {
   if (!errore) {
    setOperando(getMemoria()-operando);
    setMemoria(getOperando());
   }
 }
// moltiplicazione
 private void moltiplica() {
  if (!errore) {
   setOperando(getMemoria()*operando);
   setMemoria(getOperando());
  }
 }
// divisione
 private void dividi() {
   if (!errore) {
    setOperando(getMemoria()/operando);
    setMemoria(getOperando());
   }
 }
// richiesta risultato
 public void uguale() {
  if (!errore) {
   if (operazione=='+') addiziona();
   else if (operazione=='-') sottrai();
   else if (operazione=='*') moltiplica();
   else if (operazione=='/') dividi();
  }
 }
// esporta risultato
 public String risultato() {
  if ( operando == Double.POSITIVE_INFINITY ||
   operando == Double.NEGATIVE_INFINITY ||
   operando == Double.NaN) {
   errore = true;
   return "ERR";
  }
  else
   return Double.toString(operando);
 }
 public static void main(String[] args) {
   Calcolatrice c = new Calcolatrice();
   c.setOperando(10.0);
   c.setOperazione('+');
   c.setOperando(20.0);
   c.uguale();
   System.out.println(c.risultato());
   c.setOperazione('/');
   c.setOperando(0.0);
   c.uguale();
   System.out.println(c.risultato());
   c.cancella();
   c.setOperando(20.0);
   c.setOperazione('-');
   c.setOperando(10.0);
   c.uguale();
   System.out.println(c.risultato());
   c.setOperando(10.0);
   c.setOperazione('*');
   c.setOperando(1.0);
   System.out.println(c.risultato());
   c.uguale();
 }
}